import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import org.junitpioneer.jupiter.StdIo;
import tasks.Graph;

import java.util.List;

public class GraphTest {

  /* The following "tests" are not really unit tests! They are here to show how @StdIo works! */

  @Test
  @DisplayName("An directed graph with four vertices and five edges")
  @StdIo({"4 5 2 1 4 3 1 4 2 4 3 2"})
  public void example1() {
    List<Graph.Edge>[] adj = Graph.read();
    Graph.print(adj);
  }

  @Test
  @DisplayName("A directed graph with five vertices and eight edges")
  @StdIo({"5 8 4 3 1 2 3 1 3 4 2 5 5 1 5 4 5 3"})
  public void example2() {
    List<Graph.Edge>[] adj = Graph.read();
    Graph.print(adj);
  }

  @Test
  @DisplayName("A directed graph with five vertices and one edge")
  @StdIo({"5 1 4 3"})
  public void example3() {
    List<Graph.Edge>[] adj = Graph.read();
    Graph.print(adj);
  }
}