package tasks;

import org.junit.jupiter.api.Test;
import org.junitpioneer.jupiter.StdIo;
import org.junitpioneer.jupiter.StdOut;

import java.util.List;

import static org.junit.jupiter.api.Assertions.*;

public class Task2Test {

  private boolean outputContains(String[] expected, StdOut out) {
    String[] output = out.capturedLines();

    if (expected.length != output.length) {
      return false;
    }

    for (int i = 0; i < output.length; i++) {
      if (!expected[i].equals(output[i])) {
        return false;
      }
    }
    return true;
  }

  @Test
  @StdIo({"4 3 1 2 4 1 3 1"})
  public void example1(StdOut out) {
    List<Graph.Edge>[] adj = Graph.read();
    // Do not call Graph.print as it will write to "out" object
    Task2.order(adj);
    assertTrue(outputContains(new String[]{"4", "3", "1", "2"}, out) ||
        outputContains(new String[]{"3", "4", "1", "2"}, out));
  }

  @Test
  @StdIo({"5 7 2 1 3 2 3 1 4 3 4 1 5 2 5 3"})
  public void example2(StdOut out) {
    List<Graph.Edge>[] adj = Graph.read();
    // Do not call Graph.print as it will write to "out" object
    Task2.order(adj);
    assertTrue(outputContains(new String[]{"4", "5", "3", "2", "1"}, out) ||
        outputContains(new String[]{"5", "4", "3", "2", "1"}, out));
  }


  // You are encouraged but not required to add more tests.
}